#include <iostream>
#include <fstream>
#include "Pokemon.h"

using namespace std;


int main(int argc, char* argv[]) {
    cout << "You passed " << argc << " command-line parameters." << endl;
    cout << "Welcome to Employee Database";
    cout << " Here is all the employee information" << endl;

    // Check if a filename is provided as a command-line parameter
        if (argc != 2) {
            cerr << "Usage: " << argv[0] << "Please enter the program name followed by the file name." << endl;
            return 1; // Return an error code
        }
    
    ifstream ifs;
    ifs.open(argv[1], ios::in);
    
    
    if (!ifs.is_open()) {
            cerr << "Error opening file: " << argv[1] << endl;
            return 1; // Return an error code
        }
    

    
    string name, jobTitle, firstLine, hireYearString, idNumberString, ageString;
    int idNumber = 0, age = 0, hireYear; //local variables assigned for each part of the line
    
    
    getline(ifs, firstLine);
    
    int numberOfEmployees = stoi(firstLine); //turn the frist line into an integer
    Employee** employeeDatabase = new Employee*[numberOfEmployees]; //create a array with cells equal to number of lines

    //my first for-loop reads from the file
    for (int i=0; i<numberOfEmployees; i++) {
        getline(ifs, name, '|');
        getline(ifs, idNumberString, '|');
        getline(ifs, ageString, '|');
        getline(ifs, jobTitle, '|');
        getline(ifs, hireYearString);
        
        //now I need to convert the string numbers to integers
        
        hireYear = stoi(hireYearString);
        
        idNumber = stoi(idNumberString);
        
        age = stoi(ageString);
        
        employeeDatabase[i] = new Employee(name, idNumber, age, jobTitle, hireYear);
        
        
    }
    
    

    
    
    
    /*for (int i=0; i < numberOfQueries; i++) {
        
        string queryString;
        getline(ifs, queryString);
        
        int queryID = stoi(queryString);
        int comparisons = 0; // Variable to count the number of comparisons for this query
        
        bool found = false;
        
        //NEW CODE
        int startOfArray = 0;
        int endOfArray = numberOfEmployees;
        int middleOfArray;
        
        while (startOfArray < endOfArray){
            
            comparisons++;
            
            middleOfArray = ((startOfArray + endOfArray)/2);
            if (queryID <= employeeDatabase[middleOfArray]-> getID()) {
                endOfArray = middleOfArray;
            } else {
                startOfArray = middleOfArray + 1;
            }
            
        }
        
        //return endOfArray;
        
        
        if (queryID == employeeDatabase[endOfArray]-> getID()) {
            
            found = true;
            cout << "FOUND" << endl;
            employeeDatabase[endOfArray]->talk();
            cout << "at index " << endOfArray << " after "<< comparisons << " comparisons." << endl;
            
            totalComparisons += comparisons; // Accumulate comparisons for all queries
        }
        
        

            // If no match is found, print "NOT FOUND"
        if (!found) {
            cout << "NOT FOUND" << endl;
        }
        
        
        
        
    }
    
    // Print the average number of comparisons
    double averageComparisons = static_cast<double>(totalComparisons) / numberOfQueries;
    cout << "Done! Average amount of work per query: " << averageComparisons << " comparisons." << endl;
     
    */
    
    
    //NEW CODE
    int comparisons = 0;
    
    for (int i=0; i <= numberOfEmployees-2; i++) {
        for (int j= numberOfEmployees -1 ; j>= i+1; j--) {
            
            comparisons++;
          
            int currentQuery = employeeDatabase[j]-> getID();
            int queryMinusOne = employeeDatabase[j-1]-> getID();
                    
            if (currentQuery < queryMinusOne) {
                Employee* temp = employeeDatabase[j-1];
                employeeDatabase[j-1] = employeeDatabase[j];
                employeeDatabase[j] = temp;
                
                /*for (int k = 0; k < numberOfEmployees; k++) {
                    cout << employeeDatabase[k]-> getID();
                }
                cout << endl;*/
                
                        
            }
                            
        }
    }
    
    cout << "It took " << comparisons << " comparisons to sort the data." << endl;
     
    
    ofstream sortedFile("Sorted_Employee_Data.txt");
    
    if (!sortedFile.is_open()) {
            cerr << "Error opening sorted file for writing." << endl;
            return 1; // Return an error code
        }
    
    for (int i = 0; i < numberOfEmployees; i++) {
        sortedFile << employeeDatabase[i]->getName() << "|"
                    << employeeDatabase[i]->getID() << "|"
                    << employeeDatabase[i]->getAge() << "|"
                    << employeeDatabase[i]->getJob() << "|"
                    << employeeDatabase[i]->getHireYear() << endl;
    }
    
    sortedFile << "It took " << comparisons << " comparisons to sort the data." << endl;
    sortedFile.close();


    return 0;
}

/*
 * multi
 * line
 * comment
 */
